import { useLocale } from 'element-plus'

/**
 * 通用js方法封装处理
 */

// 日期格式化
export function parseTime(time, pattern) {
  if (arguments.length === 0 || !time) {
    return null
  }
  const format = pattern || '{y}-{m}-{d} {h}:{i}:{s}'
  let date
  if (typeof time === 'object') {
    date = time
  } else {
    if ((typeof time === 'string') && (/^[0-9]+$/.test(time))) {
      time = parseInt(time)
    } else if (typeof time === 'string') {
      time = time.replace(new RegExp(/-/gm), '/').replace('T', ' ').replace(new RegExp(/\.[\d]{3}/gm), '');
    }
    if ((typeof time === 'number') && (time.toString().length === 10)) {
      time = time * 1000
    }
    date = new Date(time)
  }
  const formatObj = {
    y: date.getFullYear(),
    m: date.getMonth() + 1,
    d: date.getDate(),
    h: date.getHours(),
    i: date.getMinutes(),
    s: date.getSeconds(),
    a: date.getDay()
  }
  const time_str = format.replace(/{(y|m|d|h|i|s|a)+}/g, (result, key) => {
    let value = formatObj[key]
    // Note: getDay() returns 0 on Sunday
    if (key === 'a') { return ['日', '一', '二', '三', '四', '五', '六'][value] }
    if (result.length > 0 && value < 10) {
      value = '0' + value
    }
    return value || 0
  })
  return time_str
}

// 表单重置
export function resetForm(refName) {
  if (this.$refs[refName]) {
    this.$refs[refName].resetFields();
  }
}

// 添加日期范围
export function addDateRange(params, dateRange, propName) {
  let search = params;
  search.params = typeof (search.params) === 'object' && search.params !== null && !Array.isArray(search.params) ? search.params : {};
  dateRange = Array.isArray(dateRange) ? dateRange : [];
  if (typeof (propName) === 'undefined') {
    search.params['beginTime'] = dateRange[0];
    search.params['endTime'] = dateRange[1];
  } else {
    search.params['begin' + propName] = dateRange[0];
    search.params['end' + propName] = dateRange[1];
  }
  return search;
}

// 回显数据字典
export function selectDictLabel(datas, value) {
  if (value === undefined) {
    return "";
  }
  var actions = [];
  Object.keys(datas).some((key) => {
    if (datas[key].value == ('' + value)) {
      actions.push(datas[key].label);
      return true;
    }
  })
  if (actions.length === 0) {
    actions.push(value);
  }
  return actions.join('');
}

// 回显数据字典（字符串数组）
export function selectDictLabels(datas, value, separator) {
  if (value === undefined || value.length ===0) {
    return "";
  }
  if (Array.isArray(value)) {
    value = value.join(",");
  }
  var actions = [];
  var currentSeparator = undefined === separator ? "," : separator;
  var temp = value.split(currentSeparator);
  Object.keys(value.split(currentSeparator)).some((val) => {
    var match = false;
    Object.keys(datas).some((key) => {
      if (datas[key].value == ('' + temp[val])) {
        actions.push(datas[key].label + currentSeparator);
        match = true;
      }
    })
    if (!match) {
      actions.push(temp[val] + currentSeparator);
    }
  })
  return actions.join('').substring(0, actions.join('').length - 1);
}

// 字符串格式化(%s )
export function sprintf(str) {
  var args = arguments, flag = true, i = 1;
  str = str.replace(/%s/g, function () {
    var arg = args[i++];
    if (typeof arg === 'undefined') {
      flag = false;
      return '';
    }
    return arg;
  });
  return flag ? str : '';
}

// 转换字符串，undefined,null等转化为""
export function parseStrEmpty(str) {
  if (!str || str == "undefined" || str == "null") {
    return "";
  }
  return str;
}

// 数据合并
export function mergeRecursive(source, target) {
  for (var p in target) {
    try {
      if (target[p].constructor == Object) {
        source[p] = mergeRecursive(source[p], target[p]);
      } else {
        source[p] = target[p];
      }
    } catch (e) {
      source[p] = target[p];
    }
  }
  return source;
};

/**
 * 构造树型结构数据
 * @param {*} data 数据源
 * @param {*} id id字段 默认 'id'
 * @param {*} parentId 父节点字段 默认 'parentId'
 * @param {*} children 孩子节点字段 默认 'children'
 */
export function handleTree(data, id, parentId, children) {
  let config = {
    id: id || 'id',
    parentId: parentId || 'parentId',
    childrenList: children || 'children'
  };

  var childrenListMap = {};
  var nodeIds = {};
  var tree = [];

  for (let d of data) {
    let parentId = d[config.parentId];
    if (childrenListMap[parentId] == null) {
      childrenListMap[parentId] = [];
    }
    nodeIds[d[config.id]] = d;
    childrenListMap[parentId].push(d);
  }

  for (let d of data) {
    let parentId = d[config.parentId];
    if (nodeIds[parentId] == null) {
      tree.push(d);
    }
  }

  for (let t of tree) {
    adaptToChildrenList(t);
  }

  function adaptToChildrenList(o) {
    if (childrenListMap[o[config.id]] !== null) {
      o[config.childrenList] = childrenListMap[o[config.id]];
    }
    if (o[config.childrenList]) {
      for (let c of o[config.childrenList]) {
        adaptToChildrenList(c);
      }
    }
  }
  return tree;
}

/**
* 参数处理
* @param {*} params  参数
*/
export function tansParams(params) {
  let result = ''
  for (const propName of Object.keys(params)) {
    const value = params[propName];
    var part = encodeURIComponent(propName) + "=";
    if (value !== null && value !== "" && typeof (value) !== "undefined") {
      if (typeof value === 'object') {
        for (const key of Object.keys(value)) {
          if (value[key] !== null && value[key] !== "" && typeof (value[key]) !== 'undefined') {
            let params = propName + '[' + key + ']';
            var subPart = encodeURIComponent(params) + "=";
            result += subPart + encodeURIComponent(value[key]) + "&";
          }
        }
      } else {
        result += part + encodeURIComponent(value) + "&";
      }
    }
  }
  return result
}


// 返回项目路径
export function getNormalPath(p) {
  if (p.length === 0 || !p || p == 'undefined') {
    return p
  };
  let res = p.replace('//', '/')
  if (res[res.length - 1] === '/') {
    return res.slice(0, res.length - 1)
  }
  return res;
}

// 验证是否为blob格式
export function blobValidate(data) {
  return data.type !== 'application/json'
}

// 判断是否含有大写字母
export function hasCapital(str)
{
    var result = str.match(/^.*[A-Z]+.*$/);
    if(result==null) return false;
    return true;
}

// 判断是否含有小写字母
export function hasLowercase(str)
{
    var result = str.match(/^.*[a-z]+.*$/);
    if(result==null) return false;
    return true;
}

// 判断是否含有数字
export function hasNumber(str)
{
    var result = str.match(/^.*[0-9]+.*$/);
    if(result==null) return false;
    return true;
}

// #,@,!
export function hasOther2(str)
{
    var result = str.match(/^.*[\#\@\!]+.*$/);
    if(result==null) return false;
    return true;
}

/**
 * 拆分整数与小数
 * @param {*} value 数字 
 * @param {*} num 小数位数
 */
export function splitNum(value, num) {
  if (!value) {
    value = 0
  }
  const tmp = value.toFixed(num || 2)
  return tmp.split('.')
}

export function isNumber(value) {
  return typeof value === 'number' && !isNaN(value);
}

export function isEmpty(str) {
  if (isNumber(str)) str = str + '' //改为字符串，避免传入Number判定为空 add by mb 0526
  if (str == "undefined" || str == 'null' || str == null || str == "" || str == undefined) {
      return true;
  } else {
      return false;
  }
}

export function getUserTypeHtml(value, row) {
  const { t } = useLocale()
  if(isEmpty(value)) return '';
  if(value==0 || value=='0'){
      return '<span>'+t('common.emp')+'</span>'
  }else if(value==1 || value=='1'){
      return '<span>'+t('common.ib')+'</span>'
  }else if(value==2 || value=='2'){
      return '<span>'+t('common.customer')+'</span>'
  }else{
      return '';
  }
}

export function getPayTypeHtml(value, row) {
  const { t } = useLocale()
  if (value == 0)
      return t('pay.type0');
  if (value == 1)
      return t('pay.type1');
  return '-';
}

export function returnFloat(value) {
  if(isEmpty(value)) return '0.00';
  var value = Math.round(parseFloat(value) * 100) / 100;
  var s = value.toString().split(".");
  if (s.length == 1) {
      value = value.toString() + ".00";
      return value;
  }
  if (s.length > 1) {
      if (s[1].length < 2) {
          value = value.toString() + "0";
      }
      return value;
  }
}

export function returnFloat3(value) {
  if(isEmpty(value)) return '0.000';
  var value = Math.round(parseFloat(value) * 1000) / 1000;
  var s = value.toString().split(".");
  if (s.length == 1) {
      value = value.toString() + ".000";
      return value;
  }
  if (s.length > 1) {
      if (s[1].length == 1) value = value.toString() + "00";
      if (s[1].length == 2) value = value.toString() + "0";
      return value;
  }
}

export function getBlank(str) {
  if (isEmpty(str)) return "";
  else return str;
}

export function getSubsidyHtml(value, row) {
  let subsidy = getBlank(value);
  if(subsidy != null && subsidy != ''){
      subsidy = subsidy + '%';
  }
  return subsidy;
}

export function getSubsidyAmountHtml(value, row) {
  let subsidy_amount = getBlank(value);
  if(subsidy_amount != null && subsidy_amount != ''){
      subsidy_amount = '$'+subsidy_amount;
  }
  return subsidy_amount;
}

export function getTransferTypeHtml(value, row) {
  const { t } = useLocale()
  if(row.transfer_type==1){
      return '<img style="width:20px;height:20px;" src="'+new URL('@/assets/images/transfer-type-1.png', import.meta.url)+'" title="'+t('form.transType.1')+'" class="transfer-type-img">('+getBlank(row.mt4_login_name)+')';
  }else{
      return '<img style="width:20px;height:20px;" src="'+new URL('@/assets/images/transfer-type-0.png', import.meta.url)+'" title="'+t('form.transType.0')+'" class="transfer-type-img">';
  }
}

export function getOrderStatus(status) {
  const { t } = useLocale()
  if (status == '0')
      return t('activity.auditStatus-1')
  if (status == '1')
      return t('activity.delivered')
  if (status == '2')
      return t('activity.auditStatus2')
  if (status == '3')
      return t('activity.shippingNow')
  if (status == '4')
      return t('activity.shipped')
  if (status == '5')
      return t('activity.auditStatus-2')
}

export function typeFormatter(value, row) {
  const { t } = useLocale()
  switch (value) {
      case 'ADJUST':
          return t('activity.integralType.ADJUST')
      case 'OWN_TRADE':
          return t('activity.integralType.OWN_TRADE')
      case 'SUB_TRADE':
          return t('activity.integralType.SUB_TRADE')
      case 'STORE_EXCHANGE':
          return t('activity.integralType.STORE_EXCHANGE')
      case 'NO_TRADE_DEDUCT':
          return t('activity.integralType.NO_TRADE_DEDUCT')
      default:
          return value
  }
}

//v表示要转换的值
// e表示要保留的位数
export function round(v,e){
  var t=1;
  for(;e>0;t*=10,e--);
  for(;e<0;t/=10,e++);
  return Math.round(v*t)/t;
}